﻿using UnityEngine;
using HarmonyLib;
using System;

public class FriendlyPurifier : Mod
{
    public void Start()
    {

        this.initFriendlyPurifiers();

        Debug.Log("Mod Friendly Purifier has been loaded!");
    }

    public void Update () {
        this.initFriendlyPurifiers();
    }

    public override void WorldEvent_WorldLoaded()
    {
        this.initFriendlyPurifiers();
    }

    public void OnModUnload()
    {

        if (RAPI.GetLocalPlayer() != null)
        {

            Electric_Purifier purifier = FindObjectOfType<Electric_Purifier>();
            object batteryDrainPerPumpNorm = Traverse.Create(purifier).Field("batteryDrainPerPump").GetValue() as object;

            object batteryPumpValue = Traverse.Create(purifier).Field("batteryDrainPerPump").SetValue(batteryDrainPerPumpNorm);
            Debug.Log("Battery Drain Per Pump: " + batteryPumpValue);
        }

        Destroy(gameObject);
        Debug.Log("Mod Friendly Purifier has been unloaded!");
    }

    public void initFriendlyPurifiers ()
    {
        if (RAPI.GetLocalPlayer() != null)
        {
            Electric_Purifier purifier = FindObjectOfType<Electric_Purifier>();
            object batteryDrainPerPumpNorm = Traverse.Create(purifier).Field("batteryDrainPerPump").GetValue() as object;

            if(Convert.ToInt32(batteryDrainPerPumpNorm) > 0)
            {
                object batteryPumpValue = Traverse.Create(purifier).Field("batteryDrainPerPump").SetValue(0);
                Debug.Log("Battery Drain Per Pump: " + batteryPumpValue);
            }
        }
    }
}